<div class="app-container">
    <div class="app-header">
        <mat-icon (click)="goToAngularPage()">keyboard_backspace</mat-icon>
        <h1>Databinding</h1>
    </div>
    <div class="app-content">
        <div>
            <div>
                <h3>String interpolation ( HTML <-- TS )</h3>
                <ul>
                    <li>Get value from TS field is {{ property }}</li>
                    <li>Get value from TS method is {{ getStudentName() }}</li>    
                </ul>
            </div>
            <div>
                <h3>Property binding ( HTML <-- TS )</h3>
                <button mat-raised-button color="primary" [disabled]="disablePropertyButton">Disable Property of DOM changes due to property binding</button>
            </div>
            <div>
                <h3>Event binding ( HTML --> TS )</h3>
                <button mat-raised-button color="primary" (click)="clickEvent()">Event binding</button>
                <span>Button click event triggerd {{ clickEventTriggered }} times</span>

                <input type="text" (input)="setInputEventValue($event)">
                <span>Input Event value is {{inputEventValue}}</span>
            </div>
            <div>
                <h3>Property and Event binding</h3>
                <button mat-raised-button color="primary" [disabled]="disableProperytAndEventButton">Disable Property of DOM changes due to property and event binding</button>
                <button mat-raised-button color="primary" (click)="changePropertyAndEventButtonDisableProperty()">Change property and event button disable property</button>
            </div>
            <div>
                <h3>Two way data binding ( HTML <--> TS )</h3>
                <!-- Event binding - Input element value wont be changed -->
                <input type="text" (input)="setStudentName($event)">
                <!-- Event binding & Property Binding - Input element value wont be changed -->
                <input type="text" value={{studentName}} (input)="setStudentName($event)">
                <!-- Two way data binding - Input element value will be changed (Input element value = Variable value) -->
                <input type="text" class="input-style" [(ngModel)]="studentName">
                <span>Input value is {{studentName}}</span>
            </div>
            <div>
                <h3>Local Referenc of Template</h3>
                <h5>Using #</h5>
                <input type="text" #localReferenceOfInputTemplate>
                <button mat-raised-button color="primary" (click)="setInputValue(localReferenceOfInputTemplate)">Set Value</button>
                <span>The value of Local Reference used in TS is {{ inputTemplateVal }}</span>
                
                <h5>Using Viewchild</h5>
                <input type="text" #localReferenceByViewChild>
                <button mat-raised-button color="primary" (click)="setViewChildInputValue()">Set Value</button>
                <span>The value of Local Reference used in TS is {{ viewChildVal }}</span>
            </div>


        </div>
    </div>
</div>